let fs = require('fs')
let csv = require('./csv')
let _ = require('lodash')
//const perf = require('execution-time')();
run()

async function run() {
  //  perf.start()
    let configs = await fs.readFileSync('./configs.json', 'utf8')
    configs = JSON.parse(configs)
    let arr = []
    let files = await fs.readdirSync('./work')

    for (let i = 0; i < files.length; i++)
        if (files[i].includes('.csv'))
            arr.push(csv.parse(files[i], configs.data))

    arr = await Promise.all(arr)
    let count = 0
    let arr2 = []
    let arr3 = []
    for (let i = 0; i < arr.length; i++) {
        let inline = arr[i]
        for (let j = 0; j < inline.length; j++) {
            arr2.push(inline[j])




        }
    }
    //   console.log(arr2)

    arr2 = _.orderBy(arr2, [configs.sort], ['desc']);
    let arr20Max=[]
    let arrReserv=_.orderBy(arr2, ['percentage'], ['asc']);
    let arrResrv200=[]
    for (let i = 0; i < 200; i++) {
        arr3.push(arr2[i])
        arrResrv200.push(arrReserv[i])
    }

    for (let i=0;i<arr2.length;i++)
    {
        let t=(arr2[i].maxAllocatedMoney)/Math.abs(arr2[i].maxReseve)
        if (t<configs.alocatedReserve)
            arr20Max.push(arr2[i])
    }


    // for (let i=0;i<files.length;i++)

    createfile(JSON.stringify(arr2, null, 2))
    createfile2(JSON.stringify(arr3, null, 2))
    createfileADV('percentage',JSON.stringify(arrReserv, null, 2))
    createfileADV('percentage200',JSON.stringify(arrResrv200, null, 2))
    createfileADV('allocatedReserve',JSON.stringify(arr20Max, null, 2))
   // console.log(perf.stop())
    console.log('Done')
    //   process.exit(0)
    // console.log(d)
}

function createfile(data) {
    return new Promise(function (resolve, reject) {
        fs.writeFile('work/result.json', data, 'utf8', function (err) {
            if (err) reject(err);
            else resolve(data);
        });
    });
}

function createfileADV(filename,data) {
    return new Promise(function (resolve, reject) {
        fs.writeFile('work/'+filename+'.json', data, 'utf8', function (err) {
            if (err) reject(err);
            else resolve(data);
        });
    });
}


function createfile2(data) {
    return new Promise(function (resolve, reject) {
        fs.writeFile('work/result2.json', data, 'utf8', function (err) {
            if (err) reject(err);
            else resolve(data);
        });
    });
}


async function test2() {
    let configs = await fs.readFileSync('./configTemp.json', 'utf8')
    configs = JSON.parse(configs)
    console.log(configs)
}



